/**
Action Script library. NetConnection class implementation
Copyright (C) 2005

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_net_connection.hh"

typedef void (ASNetConnection::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASNetConnection::init,			// 0
	&ASNetConnection::connect,
	// Need to be at the end.
	&ASNetConnection::addProperty,		
	&ASNetConnection::registerClass,	
	&ASNetConnection::AStoString,		
	&ASNetConnection::unwatch,			
	&ASNetConnection::valueOf,			
	&ASNetConnection::watch
};

/**
 * The constructor
 **/
ASNetConnection::ASNetConnection(Script *s, Graphics *g) : ASObject(s,g,L"NetConnection") {
}

/**
 * The constructor
 **/
ASNetConnection::~ASNetConnection() {
}

/**
 * Return a function descriptor
 */
Function *ASNetConnection::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"NetConnection")	{func->setFunctionIndex(0); func->setNumParams(0); }
	if (memberName == L"connect") 		{func->setFunctionIndex(1); func->setNumParams(1); }
	finishFunctionSetup(memberName,2,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASNetConnection::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASNetConnection::init() {
	puts("TODO");
}

/**
 * Opens a local connection through which you can play back video (FLV) files from an HTTP address or from the local file system.
 **/
void ASNetConnection::connect() {
	puts("TODO");
	noReturnValue();
}

