/**
Action Script library. Object class definition
Copyright (C) 2005  Christophe Choquet (cchoquet@users.sourceforge.net)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _AS_OBJECT_HH
#define _AS_OBJECT_HH
#include "as_interface.hh"

class ASObject : public ASInterface{
public:
	ASObject(ASObject*);
	ASObject(Script *s, Graphics *g);
	ASObject(Script *s, Graphics *g, wstring className);
	~ASObject();
	Function *getFunctionMember(wstring memberName);
	void 	callFunction(Function *f);
	void 	init();
	ASInterface*getNewInstance(Script *s,Graphics *g) { return new ASObject(s,g); }
	virtual void 	setMainMember(ValueObject  *v);
	ASObject *getListener(wstring s) { return listeners[s]; }
	virtual ValueObject*getMember(wstring memberName);
	virtual void	setMember(wstring memberName, ValueObject *v);

	virtual void	addProperty();
	virtual void	registerClass();
	virtual void	AStoString();
	virtual void	unwatch();
	virtual void	valueOf();
	virtual void	watch();
/*	char	__proto__;*/
protected:
	map<wstring,ASObject*> listeners;	// event listeners
private:
	StringFunctionHashMap getFuncs;
	StringFunctionHashMap setFuncs;
};
#endif
