/**
Action Script library. TextFieldStylesheet class implementation
Copyright (C) 2005

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_text_field_stylesheet.hh"

typedef void (ASTextFieldStyleSheet::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASTextFieldStyleSheet::init,			// 0
	&ASTextFieldStyleSheet::getStyle,		// 1
	&ASTextFieldStyleSheet::getStyleNames,	// 2
	&ASTextFieldStyleSheet::load,			// 3
	&ASTextFieldStyleSheet::parseCSS,		// 4
	&ASTextFieldStyleSheet::setStyle,		// 5	
	// Need to be at the end.
	&ASTextFieldStyleSheet::addProperty,		
	&ASTextFieldStyleSheet::registerClass,	
	&ASTextFieldStyleSheet::AStoString,		
	&ASTextFieldStyleSheet::unwatch,			
	&ASTextFieldStyleSheet::valueOf,			
	&ASTextFieldStyleSheet::watch

};

/**
 * The constructor
 **/
ASTextFieldStyleSheet::ASTextFieldStyleSheet(Script *s, Graphics *g) : ASObject(s,g,L"TextField.StyleSheet") {
}

/**
 * The destructor
 **/
ASTextFieldStyleSheet::~ASTextFieldStyleSheet() {
}

/**
 * Return a function descriptor
 */
Function *ASTextFieldStyleSheet::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"TextField.StyleSheet"){func->setFunctionIndex(0); func->setNumParams(0); }
	if (memberName == L"getStyle") 			{func->setFunctionIndex(1); func->setNumParams(1); }
	if (memberName == L"getStyleNames") 	{func->setFunctionIndex(2); func->setNumParams(0); }
	if (memberName == L"load") 				{func->setFunctionIndex(3); func->setNumParams(1); }
	if (memberName == L"parseCSS") 			{func->setFunctionIndex(4); func->setNumParams(1); }
	if (memberName == L"setStyle") 			{func->setFunctionIndex(5); func->setNumParams(2); }
	finishFunctionSetup(memberName,6,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASTextFieldStyleSheet::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}
/**
 *
 **/
void ASTextFieldStyleSheet::init() {
	puts("TODO");
}

/**
 * Returns a copy of the style sheet object associated with a specified style name.
 **/
void ASTextFieldStyleSheet::getStyle() {
	puts("TODO");
	noReturnValue();
}

/**
 * Returns an array that contains the names of all of the styles registered in the style sheet object.
 **/
void ASTextFieldStyleSheet::getStyleNames() {
	puts("TODO");
	noReturnValue();
}

/**
 * Begins loading a CSS file into the style sheet object.
 **/
void ASTextFieldStyleSheet::load() {
	puts("TODO");
	noReturnValue();
}

/**
 * Parses a string of CSS text and creates the specified style.
 **/
void ASTextFieldStyleSheet::parseCSS() {
	puts("TODO");
	noReturnValue();
}

/**
 * Adds a new style to the style sheet object.
 **/
void ASTextFieldStyleSheet::setStyle() {
	puts("TODO");
	noReturnValue();
}
