/**
Action Script library. TextSnapshot class implementation
Copyright (C) 2005

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_text_snapshot.hh"

typedef void (ASTextSnapshot::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASTextSnapshot::init,				// 0
	&ASTextSnapshot::findText,			// 1
	&ASTextSnapshot::getCount,			// 2
	&ASTextSnapshot::getSelected,		// 3
	&ASTextSnapshot::getSelectedText,	// 4
	&ASTextSnapshot::getText,			// 5
	&ASTextSnapshot::hitTestTextNearPos,// 6
	&ASTextSnapshot::setSelectColor,	// 7
	&ASTextSnapshot::setSelected,		// 8
	// Need to be at the end.
	&ASTextSnapshot::addProperty,		
	&ASTextSnapshot::registerClass,	
	&ASTextSnapshot::AStoString,		
	&ASTextSnapshot::unwatch,			
	&ASTextSnapshot::valueOf,			
	&ASTextSnapshot::watch
};

/**
 * The constructor
 **/
ASTextSnapshot::ASTextSnapshot(Script *s, Graphics *g) : ASObject(s,g,L"TextSnapshot") {
}

/**
 * The destructor
 **/
ASTextSnapshot::~ASTextSnapshot() {
}

/**
 * Return a function descriptor
 */
Function *ASTextSnapshot::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"TextSnapshot")	 	{func->setFunctionIndex(0); func->setNumParams(0); }
	if (memberName == L"findText") 			{func->setFunctionIndex(1); func->setNumParams(3); }
	if (memberName == L"getCount") 			{func->setFunctionIndex(2); func->setNumParams(0); }
	if (memberName == L"getSelected") 		{func->setFunctionIndex(3); func->setNumParams(2); }
	if (memberName == L"getSelectedText") 	{func->setFunctionIndex(4); func->setNumParams(1); }
	if (memberName == L"getText") 			{func->setFunctionIndex(5); func->setNumParams(3); }
	if (memberName == L"hitTestTextNearPos"){func->setFunctionIndex(6); func->setNumParams(3); }
	if (memberName == L"setSelectColor") 	{func->setFunctionIndex(7); func->setNumParams(1); }
	if (memberName == L"setSelected") 		{func->setFunctionIndex(8); func->setNumParams(3); }
	finishFunctionSetup(memberName,9,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASTextSnapshot::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASTextSnapshot::init() {
	puts("TODO");
}

/**
 * Returns the position of the first occurrence of specified text.
 **/
void ASTextSnapshot::findText() {
	puts("TODO");
	noReturnValue();
}

/**
 * Returns the number of characters.
 **/
void ASTextSnapshot::getCount() {
	puts("TODO");
	noReturnValue();
}

/**
 * Specifies whether any of the text in the specified range has been selected by TextSnapshot.setSelected().
 **/
void ASTextSnapshot::getSelected() {
	puts("TODO");
	noReturnValue();
}

/**
 * Returns a string that contains all the characters specified by TextSnapshot.setSelected().
 **/
void ASTextSnapshot::getSelectedText() {
	puts("TODO");
	noReturnValue();
}

/**
 * Returns a string containing the characters in the specified range.
 **/
void ASTextSnapshot::getText() {
	puts("TODO");
	noReturnValue();
}

/**
 *  Lets you determine which character within the object is on or near specified coordinates.
 **/
void ASTextSnapshot::hitTestTextNearPos() {
	puts("TODO");
	noReturnValue();
}

/**
 * Specifies the color to use when highlighting characters that have been selected with the TextSnapshot.setSelected() command.
 **/
void ASTextSnapshot::setSelectColor() {
	puts("TODO");
	noReturnValue();
}

/**
 * Specifies a range of characters to be selected or deselected.
 **/
void ASTextSnapshot::setSelected() {
	puts("TODO");
	noReturnValue();
}
