/**
Action Script library. Video class definition
Copyright (C) 2005  Christophe Choquet (cchoquet@users.sourceforge.net)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _AS_VIDEO_HH
#define _AS_VIDEO_HH
#include "as_object.hh"
#include <ffmpeg/avcodec.h>
#include <ffmpeg/avformat.h>

class ASVideo : public ASObject{
public:
	ASVideo(Script *s, Graphics *g);
	~ASVideo();
	Function *getFunctionMember(wstring memberName);
	void 	callFunction(Function *f);
	void 	init();
	void 	init(DefineVideoStreamTag*);
	ASInterface*getNewInstance(Script *s,Graphics *g) { return new ASVideo(s,g); }
	void	attachVideo();
	void	clear();
	ASInterface* getObjectDeepCopy(bool deep) { return this;}

	void	toGraphic();
	void	decodeFrame(UI16 frameNum,UI8* videoData, UI32 size);
private:
	long	textureId;
	int 	codecId, width,height, width2, height2;
    AVFormatContext *pFormatCtx;
   	AVFrame         *pFrame; 
   	AVFrame         *pFrameRGB;
    AVCodec         *pCodec;
    AVCodecContext  *pCodecCtx;
	uint8_t 		*buffer;

	bool	getNextFrame(AVFormatContext *pFormatCtx, AVCodecContext *pCodecCtx, UI8*, AVFrame *pFrame, int size);
	void	freeDecoder();
};
#endif
