/**
Action Script library. XMLNode
Copyright (C) 2005 Christophe Choquet (cchoquet@users.sourceforge.net)  

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _AS_XML_NODE_HH
#define _AS_XML_NODE_HH
#include "as_object.hh"
#include <libxml/parser.h>
#include <libxml/tree.h>

class ASXmlNode : public ASObject{
public:
	ASXmlNode(Script *s, Graphics *g);
	ASXmlNode(Script *s, Graphics *g, xmlNode * node,xmlDocPtr	doc);
	~ASXmlNode();
	Function *getFunctionMember(wstring memberName);
	void 	callFunction(Function *f);
	void	init();
	ASInterface*getNewInstance(Script *s,Graphics *g) { return new ASXmlNode(s,g); }
	void 	setMember(wstring memberName, ValueObject *v);
	ValueObject*getMember(wstring memberName);
	ValueObject*getMainMember();

	void	appendChild();
	void	cloneNode();
	void	hasChildNodes();
	void	insertBefore();
	void	removeNode();
	void	AStoString();
private:
	xmlNode	*node;
	xmlDocPtr	doc;
};
#endif
