/**
Action Script library. XMLSocket class implementatation
Copyright (C) 2005

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#include "as_xml_socket.hh" 

typedef void (ASXmlSocket::*funcPtr)();
static funcPtr callbacks[]= { 
	&ASXmlSocket::init,			// 0
	&ASXmlSocket::close,		// 1
	&ASXmlSocket::connect,		// 2
	&ASXmlSocket::send,			// 3
	&ASXmlSocket::onClose,		// 4
	&ASXmlSocket::onConnect,	// 5
	&ASXmlSocket::onData,		// 6
	&ASXmlSocket::onXML,			// 7
	// Need to be at the end.
	&ASXmlSocket::addProperty,		
	&ASXmlSocket::registerClass,	
	&ASXmlSocket::AStoString,		
	&ASXmlSocket::unwatch,			
	&ASXmlSocket::valueOf,			
	&ASXmlSocket::watch
};

/**
 * The constructor
 **/
ASXmlSocket::ASXmlSocket(Script *s, Graphics *g) : ASObject(s,g,L"XMLSocket") {
}

/**
 * The desstructor
 **/
ASXmlSocket::~ASXmlSocket() {
}

/**
 * Return a function descriptor
 */
Function *ASXmlSocket::getFunctionMember(wstring memberName) {
	Function *func = getBaseFunction(memberName);
	if (memberName == L"XMLSocket")	{func->setFunctionIndex(0); func->setNumParams(0); }
	if (memberName == L"close") 	{func->setFunctionIndex(1); func->setNumParams(0); }
	if (memberName == L"connect") 	{func->setFunctionIndex(2); func->setNumParams(2); }
	if (memberName == L"send") 		{func->setFunctionIndex(3); func->setNumParams(0); }
	if (memberName == L"onClose") 	{func->setFunctionIndex(4); func->setNumParams(0); }
	if (memberName == L"onConnect")	{func->setFunctionIndex(5); func->setNumParams(1); }
	if (memberName == L"onData") 	{func->setFunctionIndex(6); func->setNumParams(0); }
	if (memberName == L"onXML") 	{func->setFunctionIndex(7); func->setNumParams(1); }
	finishFunctionSetup(memberName,8,func);
	return func;
}

/**
 * Call class built in functions
 **/
void ASXmlSocket::callFunction(Function *func) {
	numPassedParams = func->getNumPassedParams();
	(this->*callbacks[func->getFunctionIndex()])();
}

/**
 *
 **/
void ASXmlSocket::init() {
	puts("TODO");
}

/**
 * Closes an open socket connection.
 **/
void ASXmlSocket::close() {
	puts("TODO");
	noReturnValue();
}

/**
 * Establishes a connection to the specified server.
 **/
void ASXmlSocket::connect() {
	puts("TODO");
	noReturnValue();
}

/**
 * Sends an XML object to the server.
 **/
void ASXmlSocket::send() {
	puts("TODO");
	noReturnValue();
}

/**
 * An event handler that is invoked when an XMLSocket connection is closed.
 **/
void ASXmlSocket::onClose() {
	puts("TODO");
	noReturnValue();
}

/**
 * An event handler that is invoked by Flash Player when a connection request initiated through XMLSocket.connect() has succeeded or failed.
 **/
void ASXmlSocket::onConnect() {
	puts("TODO");
	noReturnValue();
}

/**
 * An event handler that is invoked when an XML message has been downloaded from the server.
 **/
void ASXmlSocket::onData() {
	puts("TODO");
	noReturnValue();
}

/**
 * An event handler that is invoked when an XML object arrives from the server.
 **/
void ASXmlSocket::onXML() {
	puts("TODO");
	noReturnValue();
}
