/**
Macromedia Flash Base Renderer definition.
Copyright (C) 2005  Christophe Choquet (cchoquet@users.sourceforge.net)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**/
#ifndef _IRENDERER_
#define _IRENDERER_
#include "common.hh"
#include "swf.hh"
#include "bgraphics.hh"

class BaseRenderer {
public:
	BaseRenderer(BaseTexture *texture);
	virtual ~BaseRenderer();
	virtual void	setBackGroundColor(RGB color);
	virtual void 	clearWindow()= 0;
	virtual void 	flush()= 0;
	virtual void	renderCharacter(ListDrawingSequence *dr,int clipDepth)= 0;
	virtual void	applyMatrix(MATRIX *m)= 0;
	virtual void	noMatrix();
	virtual void 	noCxFormWithAlpha();
	virtual void	initCharacter()= 0;
	virtual void	resetClipDepth()= 0;
	virtual void 	pushMatrix()= 0;
	virtual void 	popMatrix()= 0;
	virtual void	pushCxFormWithAlpha(CXFORMWITHALPHA* c);
	virtual void	popCxFormWithAlpha();
	virtual void    getTransformMatrix(float *m)= 0;
	virtual bool	displayCaret(Caret c)= 0;
protected:
	RGB		backGroundColor;
	BaseTexture *texture;
	float	*newTexCoords;
	float 	lineRatio;
	float	cxAlpha[4];
	float	secondPassColor[4];
	bool	hasCxAlpha;
	stack<CXFORMWITHALPHA>	cxFormWithAlphaStack;
	int		clipDepth;
	int 	highestMaskedLayer;
	int		stencilDepth;

	void	applyMatrixMaths(float *mat,MATRIX *m);
	void	updateTextureNoShader(DrawingSequence *d,DrawingEntry *de, bool isTexture, int textDim);
	void	applyCxFormWithAlpha(CXFORMWITHALPHA *);
};

#endif
